<?
/****************************************/
/* (c) 2005 Patrik Jakab                */
/*    phpAlbum.net                      */
/****************************************/

/****************************************/
/*      Constants                       */
/****************************************/

if ( file_exists("config.php")){
    include("config.php");	
}else{
    generate_header();
    echo "<font color=\"#DDBB66\">";
    echo "<h1> Welcome to phpAlbum.net!</H1>";
    echo "<h3> You have to edit config_change_it.php and rename it to config.php.<br>";
    echo " You have to define data directory, because of security issues it is recommended that this is not data/ but";
    echo " something like \"data_Ab6Lkj88KJ/\" . Thank You!</h3></font>";
    generate_footer();
    return;
}

/****************************************/
/*      Functions                       */
/****************************************/

function put_default_quality_settings(){
global $data_dir;
 	/*create default quality settings*/
	/*thmb_size:thmb_quality:image_size(0=original):image_quality:description*/
	$settings="160|60|0|0|original\n240|70|0|0|preview\n100|40|640|60|low\n";
	$file=fopen($data_dir."quality.dat","w");
	fwrite($file,$settings);
	fclose($file);
	chmod($data_dir."quality.dat",0640); /*to be not possible read it by others*/
}


/****************************************/
/*      SETTINGS                 */
/****************************************/

function read_settings(){
 global $setup_password,$album_dir,$data_dir,$cache_dir,$site_name,$logo_path,$logo_enabled;
 global $quality_settings;
 global $cmd,$var1,$var2;
 global $logs_enabled,$logs_filename,$logs_exclude;
 /***********************/
 /*read main_setup      */
 /***********************/
 
 if(!file_exists($data_dir."main_setup.dat")){
 	 $cmd="setup";
	 $var1="main";
	return;
 }
 $file=file($data_dir."main_setup.dat");
 $setup_password=substr($file[0],0,strlen($file[0])-1);
 $album_dir=substr($file[1],0,strlen($file[1])-1);;
 $cache_dir=substr($file[2],0,strlen($file[2])-1);;
 $site_name=substr($file[3],0,strlen($file[3])-1);;	
 $logo_enabled=substr($file[4],0,strlen($file[4])-1);;
 $logo_path=substr($file[5],0,strlen($file[5])-1);;
 
 /***********************/
 /*read quality settings*/
 /***********************/

 if(!file_exists($data_dir."quality.dat")){
   put_default_quality_settings();
 }
 $file=file($data_dir."quality.dat");
 foreach($file as $line_num=>$line){
 	$quality_settings[]=explode("|",$line);
 }
 /***********************/
 /*read logs    settings*/
 /***********************/
 if(file_exists($data_dir."logs_setup.dat")){
	 $file=file($data_dir."logs_setup.dat");
	 $logs_settings=explode("|",$file[0]);
	 $logs_enabled=$logs_settings[0];
	 $logs_filename=$logs_settings[1];
	 $logs_exclude=$logs_settings[2];
 }

}

function get_password_for_cmd($cmd,$var1){
global $setup_password;
global $album_dir;	
	if (!strcmp($cmd,"setup")){
	    return $setup_password;
	}
	if (!strcmp($cmd,"delcache")){
	    return $setup_password;
	}
	if (!strcmp($cmd,"phpinfo")){
	    return $setup_password;
	}
	if( !strcmp($cmd,"album") ){
		if(substr($var1,-1,1)=="/")
			$var1=substr($var1,0,strlen($var1)-1);
		$sett=get_directory_settings($var1);
		return $sett[1];
	}
	return "";
	
}
function generate_password_page($cmd,$var1="",$var2=""){
	echo "<table width=\"100%\" height=\"100%\"><tr align=center><td valign=center>";
	if (strlen($var2)>0){
		echo "<font color=\"#ffffff\">Enter Password: <font><form name=\"pass\" action=\"main.php?cmd=".$cmd."&var1=".$var1."&var2=".$var2."\" method=\"post\"><input width=\"15\" name=\"p\" type=\"password\"/></from>";
	}else{
		echo "<font color=\"#ffffff\">Enter Password: <font><form name=\"pass\" action=\"main.php?cmd=".$cmd."&var1=".$var1."\" method=\"post\"><input width=\"15\" name=\"p\" type=\"password\"/></from>";
	}
	echo "</td></tr></table>";
	?>
	<script type="text/javascript">
	 document.pass.p.focus();
	</script>
	<?
}
function is_cachable($text){
		if ($text == "image") return false;
		if ($text == "setup") return false;
		if ($text == "delcache") return false;
		if ($text == "setquality") return false;
		if ($text == "album") return false;
		if ($text == "imageview") return false;
					if ( strlen($text)==0) return false;
		return true;
}

function is_cached($cache_dir,$cmd,$var1,$var2,$var3,$quality){
	//return false;
	$fn=get_cache_file_name($cache_dir,$cmd,$var1,$var2,$var3,$quality);
	return file_exists($fn);
}

function load_from_cache($cache_dir,$cmd,$var1,$var2,$var3,$quality){
	$fn=get_cache_file_name($cache_dir,$cmd,$var1,$var2,$var3,$quality);
	
	/*$file=fopen($fn,"rb");
	$doc=fread($file,filesize($fn));
	fclose($file);
	echo $doc;*/
	if($cmd == "thmb" ){
		$m_time=filemtime($fn);
		$headers=getallheaders();
		if (isset( $headers["HTTP_IF_MODIFIED_SINCE"] ) ){
			if ( date("D, d M Y H:i:s T",filemtime($fn)) == $headers["HTTP_IF_MODIFIED_SINCE"] ) {
				header('HTTP/1.0 304 Not Modified');
				exit; 
			}
		}
	
		header("Last-Modified: ".date("D, d M Y H:i:s T",$m_time) );
		header('Content-type: image/jpeg');
	}
	virtual($fn);
	
}

function get_cache_file_name($cache_dir,$cmd,$var1,$var2,$var3,$quality){
$filename=$cache_dir . "cache_";
$filename.=$cmd;
$filename.="_".str_replace(" ","_",str_replace("/","_",$var1));
$filename.="_".str_replace(" ","_",str_replace("/","_",$var2));
$filename.="_".str_replace(" ","_",str_replace("/","_",$var3));
$filename.="_".$quality;
$filename.=".cache";
return $filename;
}	

function cache_document($cache_dir,$cmd,$var1,$var2,$var3,$quality){
$doc=ob_get_contents();
//echo ob_get_length();
$filename=get_cache_file_name($cache_dir,$cmd,$var1,$var2,$var3,$quality);
//echo $filename;
$file=fopen($filename,"wb");
fwrite($file,$doc);
fclose($file);
return filemtime($filename);
}




function generate_header()
{
global $logo_path,$logo_enabled,$site_name,$site_name;
echo "<html><head><title>$site_name</title><LINK REL=\"stylesheet\" HREF=\"style.css\" TYPE=\"text/css\"></head>";
echo "<body>";
if ( file_exists($logo_path) && $logo_enabled=="true") {
echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><tr><td colspan=\"4\" align=\"center\"><a href=\"main.php?cmd=album\"><img src=\"$logo_path\" border=\"0\"></a></td></tr></table>";
 }else{
	echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><tr><td colspan=\"4\" align=\"center\"><a class=\"me\" href=\"main.php?cmd=album\"><H1>$site_name</H1></a></td></tr></table>";

}
}




function  generate_album($album_dir,$var1,$thumb_size,$thumb_quality,$quality,$passwd){
  global $quality_settings;	

	echo "<table width=\"100%\"><tr><td width=\"100%\"><b><font class=\"te\">Fotoalbum :</font>   <a  class=\"me\" href=\"main.php?cmd=album&var2=".$quality."\">Photos</a><font class=\"te\">/</font>";
	//echo $var1 . "/";
	$dirs=explode('/',$var1);
	$act_dir="";
	for($i=0;$i<count($dirs)-1;$i++){
		$act_dir.=$dirs[$i]."/";
		echo "&nbsp;<a  class=\"me\" href=\"main.php?cmd=album&var1=".$act_dir."&var2=".$quality."\">".$dirs[$i]."</a><font class=\"te\">/</font>\n";
		
	}
	echo "</b></td><td nowrap>";
	if ($quality==0){
		echo "<b>".$quality_settings[0][4]."</b>&nbsp;&nbsp;<b>/</b>&nbsp;&nbsp;<a class=\"me\" href=\"main.php?cmd=setquality&var1=1&var2=".$var1."\">".$quality_settings[1][4]."</a>&nbsp;&nbsp;<b>/</b>&nbsp;&nbsp;<a class=\"me\" href=\"main.php?cmd=setquality&var1=2&var2=".$var1."\">".$quality_settings[2][4]."</a>&nbsp;&nbsp;";
	}
	if ($quality==1){
		echo "<a class=\"me\" href=\"main.php?cmd=setquality&var1=0&var2=".$var1."\">".$quality_settings[0][4]."</a>&nbsp;&nbsp;<b>/</b>&nbsp;&nbsp;<b>".$quality_settings[1][4]."</b>&nbsp;&nbsp;<b>/</b>&nbsp;&nbsp;"."<a class=\"me\" href=\"main.php?cmd=setquality&var1=2&var2=".$var1."\">".$quality_settings[2][4]."</a>&nbsp;&nbsp;";
	}
	if ($quality==2){
		echo "<a class=\"me\" href=\"main.php?cmd=setquality&var1=0&var2=".$var1."\">".$quality_settings[0][4]."</a>&nbsp;&nbsp;<b>/</b>&nbsp;&nbsp;<a class=\"me\"href=\"main.php?cmd=setquality&var1=1&var2=".$var1."\">".$quality_settings[1][4]."</a>&nbsp;&nbsp;<b>/</b>&nbsp;&nbsp;<b>".$quality_settings[2][4]."</b>&nbsp;&nbsp";
	}
	echo "|&nbsp;&nbsp;<a class=\"me\" href=\"main.php?cmd=setup\">setup</a>";
	echo "</td></tr></table>\n";
	$dir=$album_dir . $var1;
//	echo "<table cellspacing=\"5\"><tr>";
	/*openning directories*/
	if (is_dir($dir)) {
    if ($dh = opendir($dir)) {
       while (($file = readdir($dh)) !== false) {
           if( filetype($dir . $file)=="dir" ) {
			if($file !="."  && $file !=".."){
				$filelist[]=$file;	   
			}
	   }
			
       }
       closedir($dh);
      if(sizeof($filelist)>0){
       asort($filelist);
       while ( list($key,$file)=each($filelist)){
		$blocked=false;
		if(strlen(get_password_for_cmd("album",$dir.$file))>0){
			if(!strstr($passwd,get_password_for_cmd("album",$dir.$file))){ $blocked=true;};
		}
		if($blocked){
			$dir_pic="directory_passwd.png";
		}else{
			/*test if there is some new images*/
			$diff = (time() - filemtime($dir.$file))/60/60;
			if ($diff < 48 ){
				$dir_pic="directory_new.png";
			}else{
				$dir_pic="directory.png";
			}
		}
		$sett=get_directory_settings($dir.$file);
		//var_dump($sett);
		echo "<table border=\"0\" style=\"display: inline;\" cellspacing=\"5\"><tr>\n";
		echo "<td align=\"center\">\n";
		echo "<table><tr><td>";
		echo "<a class=\"me\" href=\"main.php?cmd=album&var1=".$var1.$file."/&var2=".$quality."\" border=\"0\"><img src=\"$dir_pic\" border=\"0\"></a></td>";
		echo "<td height=\"100%\"nowrap valign=\"center\"><a class=\"me\" href=\"main.php?cmd=album&var1=".$var1.$file."/&var2=".$quality."\" border=\"0\">".$file."</a>";
		if(strlen($sett[2])>0){
			echo "<br><font class=\"desc\">".$sett[2]."</font>";
		}
		echo "</td></tr></table></a></td></tr></table>\n";

      }
     }
   }
}   
	echo "<br>";
//	echo "</tr>\n</table>";
	   /*openning files*/
	if (is_dir($dir)) {
    if ($dh = opendir($dir)) {
       while (($file = readdir($dh)) !== false) {
           if( filetype($dir . $file)=="file" || filetype($dir . $file)=="link" ) {
	   		$filelist2[]=$file;
		}
			
       }
       closedir($dh);
       if(sizeof($filelist2)>0){
       asort($filelist2);
       while ( list($key,$file)=each($filelist2)){
		if(strtoupper(substr($file,-3,3))=="JPG"){
			echo "<table style=\"display: inline;\" cellspacing=\"0\">";
			echo "<tr height=\"".($thumb_size+12+30)."\">";
			echo "<td class=\"thmb\" width=\"".($thumb_size+12+30)."\" align=\"center\" nowrap>";
			echo "<a class=\"me\" href=\"main.php?cmd=imageview&var1=".$var1.$file."&var2=".$quality."\">";
			echo "<img class=\"thmb\" src=\"main.php?cmd=thmb&var1=". $var1.$file."&var2=".$quality."\">";
			echo "</a></td></tr></table>\n";
		}
		if(strtoupper(substr($file,-3,3))=="AVI"){
			echo "<table style=\"display: inline;\" cellspacing=\"0\">";
			echo "<tr height=\"".($thumb_size+12+30)."\">";
			echo "<td class=\"thmb\" width=\"".($thumb_size+12+30)."\" align=\"center\" nowrap>";
			echo "<a class=\"me\" href=\"main.php?cmd=image&var1=".$var1.$file."&var2=".$quality."\">";
			echo "<img class=\"movie\" src=\"main.php?cmd=thmb&var1=[movie]&var2=".$quality."\">";
			echo $file."<br>size: ".round((filesize($dir.$file)/1024/1024),2)." MB</a></td></tr></table>\n";
		}
		
	}
       }
   }
   }
	   
/*	$list = scandir($dir);
	for($i=0;$i<count($list);$i++){
		echo $list[$i]."<br>";
	}
	*/
	return true;
}

function get_directory_settings($dir){
global $data_dir;
$file_name=$data_dir.str_replace(" ","_",str_replace("/","_",$dir)).".dat";
$settings[0]=$dir;
if(file_exists($file_name)){
	$file=file($file_name);
	if(strlen($file)>0){
		$params=explode("|",$file[0]);
		$settings[1]=$params[0];
		$settings[2]=$params[1];
	}else{
		$settings[1]="";
		$settings[2]="";
	}
}else{
	$settings[1]="";
	$settings[2]="";
}

return $settings;
}

function get_photos_directories($dir,$filelist){


if (is_dir($dir)) {
    if ($dh = opendir($dir)) {
       while (($file = readdir($dh)) !== false) {
           if( filetype($dir . $file)=="dir" && $file!="." && $file !="..") {
	   		$filelist[]=get_directory_settings($dir.$file);
			$filelist=get_photos_directories($dir.$file."/",$filelist);
		}
			
       }
       closedir($dh);
    }
}
return $filelist;
}
/****************************************/
/*      THMB                            */
/****************************************/

function generate_thumb($var1,$thumb_size,$thumb_quality){
  global $album_dir;
  $width = $thumb_size;
  $height = $thumb_size;
  
  // Content type
  //header('Content-type: image/jpeg');
  if($var1=="[movie]") $var1="../movie.png";
  // Get new dimensions
  list($width_orig, $height_orig) = getimagesize($album_dir.$var1);
  //$image_p = imagecreatetruecolor($width+10, $height+10);
  //$color=ImageColorAllocate( $image_p, 32, 32, 32 );
  //imagefill($image_p,0,0,$color);
  if ($width && ($width_orig < $height_orig)) {
     $width = ($height / $height_orig) * $width_orig;
  } else {
     $height = ($width / $width_orig) * $height_orig;
  }

  // Resample
  if(strtoupper(substr($var1,-3,3))=="JPG")
	  $image = imagecreatefromjpeg($album_dir.$var1);
  if(strtoupper(substr($var1,-3,3))=="PNG")
	  $image = imagecreatefrompng($album_dir.$var1);
  $image_p = imagecreatetruecolor($width, $height);
  //imagecopyresampled($image_p, $image, ($thumb_size-$width)/2+5, ($thumb_size-$height)/2+5, 0, 0, $width, $height, $width_orig, $height_orig);
  imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);

  // Output
  if(strtoupper(substr($var1,-3,3))=="JPG"){
	imagejpeg($image_p, null, $thumb_quality);
  }
  if(strtoupper(substr($var1,-3,3))=="PNG"){
  	imagepng($image_p);
  }
	
}
/****************************************/
/*      IMAGE                           */
/****************************************/

function generate_image($var1,$quality){

 global $quality_settings,$album_dir;
  $m_time=filemtime($album_dir.$var1);
  $headers=getallheaders();
  if (isset( $headers["HTTP_IF_MODIFIED_SINCE"] ) ){
	if ( date("D, d M Y H:i:s T",$m_time) == $headers["HTTP_IF_MODIFIED_SINCE"] ) {
		header('HTTP/1.0 304 Not Modified');
		exit; 
	}
  }


 if(strtoupper(substr($var1,-3,3))=="JPG"){
  // Content type
  header("Last-Modified: ".date("D, d M Y H:i:s T",$m_time) );
  header('Content-type: image/jpeg');
  
  if( $quality_settings[$quality][2] == 0){
	/*$file=fopen($var1,"rb");
	$doc=fread($file,filesize($var1));
	fclose($file);
	echo $doc;*/
	virtual($album_dir.$var1);
  }else{
	$image_low_size=$quality_settings[$quality][2];
	$width=$image_low_size;
	$height=$image_low_size;
	// Get new dimensions
	list($width_orig, $height_orig) = getimagesize($album_dir.$var1);
	if ($width && ($width_orig < $height_orig)) {
	   $width = ($height / $height_orig) * $width_orig;
	} else {
	   $height = ($width / $width_orig) * $height_orig;
	}
	$image_p = imagecreatetruecolor($width, $height);
	// Resample
	$image = imagecreatefromjpeg($album_dir.$var1);
	//$image_p = imagecreatetruecolor($width, $height);
	imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
	
	// Output
	imagejpeg($image_p, null, $quality_settings[$quality][3]);
  }
 }
 if(strtoupper(substr($var1,-3,3))=="AVI"){
  header("Last-Modified: ".date("D, d M Y H:i:s T",$m_time) );
  header("Content-type: application/download ");
  header("Content-Disposition: filename=".$var1." ");
  virtual($album_dir.$var1);
 }
}
/****************************************/
/*      DELTE CACHE                     */
/****************************************/

function delete_cache($cache_dir){
   if ($dh = opendir($cache_dir)) {
       while (($file = readdir($dh)) !== false) {
           if($file != "." && $file!=".."){
	       unlink ( $cache_dir . $file);
           	echo "deleting : ".$cache_dir.$file."<br>";
           }
			
       }
       closedir($dh);
   }
} 
/****************************************/
/*      NEXT PREV IMAGE                 */
/****************************************/

function get_next_prev_image ($var1){
   global $album_dir;
   $tmp="null";
   
   if ($dh = opendir(dirname($album_dir.$var1))) {
       while (($file = readdir($dh)) !== false) {
      	    if($file != "." && $file!=".." && (filetype(dirname($album_dir.$var1)."/".$file)=="file" ||filetype(dirname($album_dir.$var1)."/".$file)=="link") && strtoupper(substr($file,-3,3))=="JPG" ){
	    	$filelist[]=$file;
	    }
	}
       closedir($dh);
      if(sizeof($filelist)>0) {
       asort($filelist);
       while(list($key,$file)=each($filelist)){
           	if ($file == basename($var1)){
           		if($tmp!="null"){
           			$names[]=dirname($var1)."/".$tmp;
           		}else{
           			$names[]="null";
           		}
           		list($key,$file)=each($filelist);
			//echo "KEY=".$key;
			//echo "FILE=".$file;
           		if($file !== null){
           			
           			$names[]= dirname($var1)."/".$file;
           		}else{
           			$names[]= "null";
           		}
           	}
           	$tmp=$file;
           
			
       }
      }
       return $names;
   }
	
}
/****************************************/
/*      IMAGE VIEW                      */
/****************************************/

function generate_image_view($var1,$quality){
global $quality_settings,$album_dir;
echo "<div>";
echo "<table width=\"100%\"><tr>";
echo "<td nowrap>";

	echo "<b><font class=\"te\">Fotoalbum :</font>   <a  class=\"me\" href=\"main.php?cmd=album&var2=".$quality."\">Photos</a><font class=\"te\">/</font>";
	//echo $var1 . "/";
	$dirs=explode('/',$album_dir.$var1);
	$act_dir="";
	for($i=1;$i<count($dirs)-1;$i++){
		$act_dir.=$dirs[$i]."/";
		echo "&nbsp;<a  class=\"me\" href=\"main.php?cmd=album&var1=".$act_dir."&var2=".$quality."\">".$dirs[$i]."</a><font class=\"te\">/</font>\n";
		
	}

echo "</td>";

/*testing for next and previous image ..*/
list( $prev,$next) = get_next_prev_image($var1);

list($iwidth, $iheight, $itype, $iattr) = getimagesize($album_dir.$var1);
if($quality_settings[$quality][2]== 0){
	$img_size="width=\"".$iwidth."\" height=\"".$iheight."\"";
}else {
        $image_low_size=$quality_settings[$quality][2];
	$width=$image_low_size;
	$height=$image_low_size;
	if ($width && ($iwidth < $iheight)) {
	   $width = ($height / $iheight) * $iwidth;
	} else {
	   $height = ($width / $iwidth) * $iheight;
	}
	$img_size="width=\"".$width."\" height=\"".$height."\"";
}

$next_prev .= "<td width=\"100%\" align=\"right\">";
if( $prev != "null" ) { 
	$next_prev .= "<a class=\"me\" href=\"main.php?cmd=imageview&var1=".$prev."&var2=".$quality."\">previous</a>"; 
}else{
	$next_prev .= "<b>previous</b>"; 
};
$next_prev .= "&nbsp;&nbsp;<b>/</b>&nbsp;&nbsp;";
if( $next != "null" ) { 
	$next_prev .= "<a class=\"me\" href=\"main.php?cmd=imageview&var1=".$next."&var2=".$quality."\">next</a>";
}else{
	$next_prev .= "<b>next</b>";
};
echo $next_prev;
echo "</td></tr></table>";
echo "</div>";
echo "<div>";
echo "<table width=\"100%\"><tr><td align=\"center\">";
echo 		"<table cellpadding=\"20\"><tr><td bgcolor=\"#FFFFFF\">";
echo 		"<img ".$img_size." src=\"main.php?cmd=image&var1=".$var1."&var2=".$quality."\" border=\"1\" style=\"border-color: #888888\"/>";
echo 		"</td></tr></table>";
echo "</td></tr></table>";
echo "</div>";
echo "<div>";
echo "<table width=\"100%\"><tr>";
echo $next_prev;
echo "</td></tr></table>";
echo "</div>";
/*testing exif*/
/*	echo "Exif:\n";
	echo "<div><table width=\"100%\">\n";
	echo "<tr><td>";
	$exif=exif_read_data($var1);
	print_r($exif);
	echo "</td></tr>";
	echo "</table>";
	echo "</div>\n";
	$mn=$exif["Model"];
	print_r($mn);
/*          */
echo "</body>";
echo "</html>";
}
/****************************************/
/*      FOOTER                          */
/****************************************/

function generate_footer(){
     echo "<table width=\"100%\"><tr height=\"100\"><td valign=\"bottom\" align=\"center\" width=\"100%\"><font size=\"2\">Powered by <a class=\"me\"href=\"http://www.phpalbum.net\"><font size=\"2\">PHP Photo Album</font></a></font></td></tr></table>";
     echo "</body></html>";

}

/****************************************/
/*      SETUP COMMAND                   */
/****************************************/

function generate_setup_page(){
global $var1;
global $var2;
global $album_dir;
global $cache_dir;
global $data_dir;
global $setup_password;
global $logo_path,$logo_enabled,$site_name;
global $logs_enabled,$logs_filename,$logs_exclude;
	if($var1=="") {
	  generate_header();
	  require("setup.inc");
	  return;
	}
	if($var1=="main"){
	  if($var2=="save"){
	  	global $p_p,$p_pd,$p_dd,$p_cd,$p_name,$p_logo_enabled,$p_logo_path;
		$file=fopen($data_dir."main_setup.dat","w");
		if(isset($p_logo_enabled)){$p_logo_enabled="true";}else{$p_logo_enabled="false";}
		fwrite($file,"$p_p\n$p_pd\n$p_cd\n$p_name\n$p_logo_enabled\n$p_logo_path\n");
		fclose($file);
		read_settings();
	  }
	  	generate_header();
		require("setup_main.inc");
	  return;
	}
	if($var1=="logs"){
	  if($var2=="save"){
	  	global $p_enabled,$p_filename,$p_exclude;
		$file=fopen($data_dir."logs_setup.dat","w");
		if(isset($p_enabled)){
		        fwrite($file,"true|$p_filename|$p_exclude");
		}else{
		        fwrite($file,"false|$p_filename|$p_exclude");
		}
		fclose($file);
		read_settings();
	  }
	  if($var2=="view"){
	  	generate_header();
                require("setup_logs.inc");
		if(file_exists($cache_dir.$logs_filename)){
			$file=file($cache_dir.$logs_filename);
			echo "<table>";
	        	foreach($file as $line_num=>$line){
 	                	$strings=explode("|",$line);
				echo "<tr>";
				foreach($strings as $num=>$string){
					echo "<td class=\"boxbody\">".$string."</td>";
				}	
				echo "<td class=\"boxbody\"><a class=\"me\" href=\"main.php?cmd=".$strings[1]."&var1=".$strings[2]."\">view<a/></td>";
				echo "</tr>";
                	}
			echo "</table>";
		}else{ echo "Log file not found !!";}
		return;
	  }
	  if($var2=="del"){
	  	  generate_header();
		  require("setup_logs.inc");
		  if(file_exists($cache_dir.$logs_filename)){
		  	unlink($cache_dir.$logs_filename);
			echo "File deleted";
		  }else{
		  	echo "File not found!";
		  }
		  return;	
	  }
	  generate_header();
	  require("setup_logs.inc");
	  return;
	}
	if($var1=="dirs"){
	  if($var2=="save"){
	  	$num=0;
		while(isset($_GET["p_dir_".$num])){
			$file=fopen($data_dir.str_replace(" ","_",str_replace("/","_",$_GET["p_dir_".$num])).".dat","w");
			fwrite($file,$_GET["p_pass_".$num]."|".$_GET["p_desc_".$num]);
			fclose($file);
			$num=$num+1;
		}
	  }
	  generate_header();
	  $dirs=get_photos_directories($album_dir,$dirs);
	  require("setup_dirs.inc");
	  return;
	}
	if($var1=="cache"){
	  generate_header();
	  require("setup.inc");
	  return;
	}
        require("setup.inc");
}
function write_log(){
global $logs_enabled,$logs_exclude,$cmd,$var1,$logs_filename,$cache_dir,$passwd;
	if($logs_enabled=="true"){
	  $strings=explode(";",$logs_exclude);
	  $found="false";
	  $host=gethostbyaddr($_SERVER['REMOTE_ADDR']);
	  foreach($strings as $num=>$string){
	  	if(strlen($string)>0)
	  		if(strstr($host,$string))$found="true";
	  }
	  if($found=="false"){
	  	$file_log=fopen($cache_dir.$logs_filename,"a");
	  	fwrite($file_log,date("D M j G:i:s T Y")."|".$cmd."|".$var1."|".$_SERVER['REMOTE_ADDR']."|".$host."|".$passwd."\n");
	  	fclose($file_log);
	  }
	}
}

/****************************************/
/*      Start Program v0.               */
/****************************************/

/*ob_start*/

read_settings();

if($cmd=="setquality"){
	$quality=$var1;
	setcookie("phpAlbum_quality",$quality,time()+60*60*24*365);
	$cmd="album";$var1=$var2;$var2="";$var3="";
}else{
	if(isset($_COOKIE["phpAlbum_quality"])){
		$quality=$_COOKIE["phpAlbum_quality"];
	}else{
	        $quality=0;
	}
	if($quality != 0 && $quality != 1 && $quality!= 2 ){
		$quality=0;
		setcookie("phpAlbum_quality",$quality,time()+60*60*24*365);
	}
}
$thumb_size=$quality_settings[$quality][0];
$thumb_quality=$quality_settings[$quality][1];

$passwd=$_COOKIE["phpAlbum_passwd"];
if (isset($p)){
	$passwd.="_".$p."_";
	setcookie("phpAlbum_passwd",$passwd,time()+60*60*24*365);
}
/*is cachable then try to loade from cache*/
/*if (isset( $_SERVER["HTTP_IF_MODIFIED_SINCE"] ) ){
		header('HTTP/1.0 304 Not Modified');
		exit; 
}*/
$passwd_req=get_password_for_cmd($cmd,$album_dir.$var1);
if($passwd_req!="" && !strstr($passwd,$passwd_req) ){
		/*need a password */
		generate_header();
		generate_password_page($cmd,$var1,$var2);
		generate_footer();
		return;
}

if(is_cachable($cmd)) {
	if(is_cached($cache_dir,$cmd,$var1,$var2,$var3,$quality)) {
		load_from_cache($cache_dir,$cmd,$var1,$var2,$var3,$quality);
		//echo "<br>Loaded from cache";
		return;
	}
}

/*header("Last-Modified: ".date("D, d M Y H:i:s T",time()) ); */
/*testing for php-info*/
$cache_this_doc=true;
ob_start();
/*testing for password */
if($cmd=="phpinfo"){
	phpinfo();
}else if($cmd=="album"){
	write_log();
	generate_header();
        $cache_this_doc=generate_album($album_dir,$var1,$thumb_size,$thumb_quality,$quality,$passwd);	
	generate_footer();
}else if($cmd=="thmb"){
        generate_thumb($var1,$thumb_size,$thumb_quality);	
}else if($cmd=="image"){
	if(strtoupper(substr($var1,-3,3))=="AVI"){
		write_log();
	}
        generate_image($var1,$quality);	
}else if($cmd=="imageview"){
	write_log();
	generate_header();
        generate_image_view($var1,$quality);	
	generate_footer();
}else if($cmd=="setup"){
        generate_setup_page();
	generate_footer();
}else if($cmd=="delcache"){
	generate_header();
        delete_cache($cache_dir);
        echo "Cache Deleted!";
	generate_footer();
}else{
	//include("header.inc");
	echo "File Not Found";
}
/*caching output*/
if(is_cachable($cmd) && $cache_this_doc){
	$m_time = cache_document($cache_dir,$cmd,$var1,$var2,$var3,$quality);
	if($cmd=="thmb" ) {
		header("Last-Modified: ".date("D, d M Y H:i:s T",$m_time) );
	}
}
ob_end_flush();
?>
